<?php
/*
Module de laison pour la Barre d'Outils OGSPY, extension firefox d'aide aux mise  jour de serveurs OGSPY

Linking MOD for OGSPY Toolbar, a firefox plugin for helping players in updating OGSPY servers game datas

Copyright (C) 2006 Naqdazar (ajdr@free.fr)

Ce programme est un logiciel libre ; vous pouvez le redistribuer et/ou le modifier
au titre des clauses de la Licence Publique Gnrale GNU, telle que publie par la
Free Software Foundation ; soit la version 2 de la Licence.
Ce programme est distribu dans l'espoir qu'il sera utile, mais SANS AUCUNE GARANTIE ;
 sans mme une garantie implicite de COMMERCIABILITE ou DE CONFORMITE A UNE UTILISATION PARTICULIERE. 
 
 Voir la Licence Publique Gnrale GNU pour plus de dtails. 
 
 Vous devriez avoir reu un exemplaire de la Licence Publique Gnrale GNU avec ce programme ;
  si ce n'est pas le cas, crivez  la Free Software Foundation Inc.,
  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.

This program is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public licence as published by the Free Software Foundation;
either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 See the GNU General Public License for more details.

You should have received a copy of the GNU General Public licence along with this program;
 if not, write to the Free Software Foundation, Inc., 
 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// contribution de Chapodepay  la restructuration du module OGS Plugin

// Creation par Benoit485 de la fonction supprimer en PHP 5.4
// Le 20 Marse 2015
if(!function_exists('import_request_variables') )
{
  function import_request_variables($type, $prefixe)
  {
    if(strpos($type, 'G')>-1)
      foreach ($_GET as $key => $val) { $GLOBALS[$prefixe.$key]=$val; }
    if(strpos($type, 'P')>-1)
      foreach ($_POST as $key => $val) { $GLOBALS[$prefixe.$key]=$val; } 
  }
}

  define("OGS_PLUGIN_DEBUG", true); // laisser la constante dfinie pour viter erreur accs journaux
  define("IN_SPYOGAME", true);
	import_request_variables('GP', "pub_");

	define("OGSPY_0304_VERCONST","3.04", true);
	define("OGSPY_0304B_VERCONST","3.04b", true);
	define("OGSPY_0301B_VERCONST","0.301b", true); //  retirer ds slection code
	define("OGSPY_0302_VERCONST","3.02", true);
	define("OGSPY_0302C_VERCONST","3.02c", true);
	define("OGSPY_031_VERCONST","3.1", true);
	define("UNISPY_010_VERCONST","1.0", true); // version Unispy 1.0 (E-Univers)
	

  //
  define("OGSPY_SCRIPTVERSION","1.92", true);
  define("PLANETNAMEEXTRACHARS", "", true);
  //--------------
  // masques expressions rgulires
  define("HTMLTAGREGEXP","#<\/?[^>]+>#", true); // masque pour dtecter la prsence de balises HTML dans un contenu
  define("PLANETLABELREGEXP","/(\S[\w\d\s_]+\S)\s(?:\((\w+)\)(?:\s))?\[(\d:\d{1,3}:\d{1,2})\]/", true); // masque de capture nom + cas lune + coordonnes
  //----------------------------------------------------------------------------
  $OGSPY_toolbarminver1="1.5"; // doit tre une valeur numrique sans elettre pour viter les blocage de test de version
  $OGSPY_toolbarminver2="1.5";// doit tre une valeur numrique sans elettre pour viter les blocage de test de version
  //----------------------
	if ($_SERVER['HTTP_USER_AGENT']!='OGSClient' && $_POST['User-Agent'] != 'OGSClient') exit("<h1>Acces direct non autorise!</h1><br>Utilisez la Barre d'Outils OGSPY : <a href=\"http://e-univers.fserv.fr/FireSpy\"><!--http://ogsteam.fr/firespy/ogsplugin_last.xpi-->Telecharger/Download</a> | <a href=\"http://naqdazar.goldzoneweb.info/forum/index.php\">Forum</a>");


  ## VIDAGES TAMPONS - NECESSAIRE POUR DEFINITION header HTTP ##
  while (@ob_end_clean());
  ob_start(); // ignore any echos to be sure that header() works
  ##############################################################################
	// substition de require("common.php"); // test formattage paramtre pose problme
	//Appel des fonctions
	require_once("parameters/id.php");
	require_once("includes/config.php");
	require_once("includes/functions.php");
	require_once("includes/mysql.php");
	require_once("includes/log.php");
	require_once("includes/galaxy.php");
	require_once("includes/user.php");
	require_once("includes/sessions.php");
  // ----------------------------------------------------	
  require_once("mod/naq_ogsplugin/ogsplugin_ogsinc.php"); ///Ogame/OGSpy/mod/naq_ogsplugin/ogsplugin_ogsinc.php
  require_once("mod/naq_ogsplugin/ogsplugin_functions.php");           
  require_once("mod/naq_ogsplugin/ogsplugincl.php");
	##############################################################################
  //
	/////////////////////////////////////////////////////////////////////////////////////
	// initialisation variables locales //tires de function user_ogs_login() user.php //
	/////////////////////////////////////////////////////////////////////////////////////

	global $fp, $db, $user_data, $user_info, $user_auth, $user_name;
	//
	$totalplanet=0;
	$totalupdated=0;
	$totalinserted=0;
	$totalfailed=0;
	$totalcanceled=0;
	//
	$playerranktables301 = array(TABLE_RANK_POINTS, TABLE_RANK_FLEET, TABLE_RANK_RESEARCH);
	$playerranktables302 = array(TABLE_RANK_PLAYER_POINTS,	TABLE_RANK_PLAYER_FLEET, TABLE_RANK_PLAYER_RESEARCH);
	$allyranktables302 = array(TABLE_RANK_ALLY_POINTS,		TABLE_RANK_ALLY_FLEET, TABLE_RANK_ALLY_RESEARCH);
	$statsranktypestrings = array ('general', 'fleet', 'research');
	//
  ///////////////////////////////
	//CONNECTION BASE DE DONNEES //
	///////////////////////////////
	//  effectu dans common.php via la classe sql_db
	//
	//
  // Vrification du dossie dbug.
	OGSPlugin_CheckDebugDir();
	//
  /* CREATION JOURNAL DEBOGGAGE */
  OGSPlugin_CreateDebugLog();
  //
	/* EST-CE UN APPEL D'UN PLUGIN OGSPY */
  if (($pub_webagent=="ogsplugin") or ($_SERVER['HTTP_USER_AGENT']=='OGSClient'))
	   $is_ogsplugin = true; else $is_ogsplugin = false;
  //
  /* INITIALISATION DB */
  if (OGSPlugin_InitDB()==false) SendHttpStatusCode("750"); // serveur mysql indisponible;
  //
  /* INITIALISATION VARIABLES SERVEUR CONFIG */
  init_serverconfig(); // fonction disponible serveur
  //global $server_config;
  
  	// dtermination du type de serveur hbergeant : OGSPY ou UNISPY

	if ((strcasecmp($server_config["version"],"3.10")>=0 || strcasecmp($server_config["version"],"1.0")>=0) && file_exists('includes/univers.php')) {
      define("SERVER_IS_UNISPY", true);
      if (defined("OGS_PLUGIN_DEBUG")) fwrite($fp, "==> Le type de serveur hbergeant dtect est UNISPY!\n");
      
      // inclusion des chanes de langue d'analyse pour les fonctions du serveur appeles
    	if (!empty($server_config['language_parsing'])) {
    		include_once("language/lang_".$server_config['language_parsing']."/lang_parsing.php");
    	} else require_once("language/lang_french/lang_parsing.php");
      
  } else if ((strcasecmp($server_config["version"],"3.10")>=0 || strcasecmp($server_config["version"],"3.02")>=0) && file_exists('includes/ogame.php')) {
      define("SERVER_IS_OGSPY", true);
      if (defined("OGS_PLUGIN_DEBUG")) fwrite($fp, "==> Le type de serveur hbergeant dtect est OGSPY!\n");
      
      if (strcasecmp($server_config["version"],"3.10")>=0) {
      
          // inclusion des chanes de langue d'analyse pour les fonctions du serveur appeles
        	if (!empty($server_config['language_parsing'])) {
        		include_once("language/lang_".$server_config['language_parsing']."/lang_parsing.php");
        	} else require_once("language/lang_french/lang_parsing.php");
      
      }
  }
  
  /*  Activation dbogage depuis le panneau d'administration du module */
	if ($server_config["naq_ogsactivate_debuglog"]==0) define("OGS_PLUGIN_DEBUG", false);
  if (defined("OGS_PLUGIN_DEBUG")) fwrite($fp, "Initialisation des variables serveurs: ".isset($server_config)." \n");
  //

  //
  //
  /* Rcupration et encodage de l'adresse ip */
	$user_ip = $_SERVER['REMOTE_ADDR'];
	//
  /* Vrifier que le module OGS Plugin n'est pas dsactiv */
  if (OGSPlugin_IsTargetModActive('naq_ogsplugin')==false) SendHttpStatusCode("796"); // notification que le module est dsactiv
  
  /**
   * Initiliasaiton variables spcifique E-Univers
   **/
   $pub_xp_mineur = 0; // 0 pour l'instant sinon lire depuis db
   $pub_xp_raideur = 0;

	
	?>
